#July 4st, 2014
#version for AMPL
#still life problem - modelled as the example in the slide
#work perfectly!

set cell;
param nbOfCell;
param m := 0;
param n := 8;
var lives {cell, cell} binary;
var nb {cell, cell} integer >=m, <=n;		#number of live neighbour

var a1 {cell, cell} binary;
var a2 {cell, cell} binary;
var a3 {cell, cell} binary;
var t1 {cell, cell} binary;
var t2 {cell, cell} binary;
var t3 {cell, cell} binary;
var t4 {cell, cell} binary;
var t5 binary;


maximize cost: sum {i in cell, j in cell} (lives[i,j]);

#######Declare how many neighbors of a certain cell are alive
subject to c1 {i in cell, j in cell}: 
	nb[i,j] = sum {x in cell, y in cell: (i<> x or j <> y) and abs(i-x) < 2 and abs(j-y) <2} lives[x,y];

#Cells with exactly three living neighbors must live
	#a1 <=> a2 & a3
	subject to c2 {i in cell, j in cell}: -a2[i,j] -a3[i,j] + 2*a1[i,j] <= 0;
	subject to c3 {i in cell, j in cell}: -a2[i,j] - a3[i,j] + a1[i,j] >= -1;
	#a2 <=> nb >= 3
	subject to c4 {i in cell, j in cell}: -nb[i,j] + 3*a2[i,j] <= 0;
	subject to c5 {i in cell, j in cell}: -nb[i,j] + 6*a2[i,j] >= -2;
	#a3 <=> nb <= 3
	subject to c6 {i in cell, j in cell}: nb[i,j] + 5*a3[i,j] <= 8;
	subject to c7 {i in cell, j in cell}: nb[i,j] + 4*a3[i,j] >= 4;
	#a1 => lives
	subject to c8 {i in cell, j in cell}: a1[i,j] <= lives[i,j];

#living cell must have exactly 2 or 3 living neighbour
#t1 <=> nb <= 3
	subject to c9 {i in cell, j in cell}: nb[i,j] + 4*t1[i,j] >= 4;
	subject to c10 {i in cell, j in cell}: nb[i,j] + 5*t1[i,j] <= 8;
#t2 <=> nb >= 2
	subject to c11 {i in cell, j in cell}: -nb[i,j] + 7*t2[i,j] >= -1;
	subject to c12 {i in cell, j in cell}: -nb[i,j] + 2*t2[i,j] <= 0;
#t3 <=> -t1 - t2 <= -2
	subject to c13 {i in cell, j in cell}: -t1[i,j] - t2[i,j] + t3[i,j] >= -1;
	subject to c14 {i in cell, j in cell}: -t1[i,j] - t2[i,j] + 2*t3[i,j] <= 0;
#t4 <=> lives - t3 <= 0
	subject to c15 {i in cell, j in cell}: lives[i,j] - t3[i,j] + 2*t4[i,j] >= 1;
	subject to c16 {i in cell, j in cell}: lives[i,j] - t3[i,j] + t4[i,j] <= 1;
#t5 <=> -sum t4 <= -U
	subject to c17: -1* sum{i in cell, j in cell} t4[i,j] + t5 >= -nbOfCell + 1;
	subject to c18: -1* sum{i in cell, j in cell} t4[i,j] + nbOfCell*t5 <= 0;
	subject to c19: t5 >= 1;
#---------------------------------------------#
#---------------------------------------------#
#option solver cbc;
#option solver conopt;
#option solver minos;
#option solver cplex;
#option solver gurobix;

solve;


printf "objective: %d\n", sum{i in cell, j in cell} lives[i,j];

printf "lives = \n";
for {i in cell}
{
	printf {j in cell}: "%4d ", lives[i,j];
	printf '\n';
}

printf "\nnb = \n";
for {i in cell}
{
	printf {j in cell}: "%4d ", nb[i,j];
	printf '\n';
}

data;
set cell := 1 2 3 4 5 6;
param nbOfCell := 36;			#=|cell|^2


